/**
 * expose worker
 *
 * You can expose any function that returns:
 * - A value
 * - A promise
 * - An iterable
 * - An async iterable
 *
 * @example
 *
 * import { exposeWorker } from 'react-hooks-worker';
 *
 * const fib = (i) => (i <= 1 ? i : fib(i - 1) + fib(i - 2));
 *
 * exposeWorker(fib);
 */
export declare function exposeWorker(func: (data: any) => any): void;
